/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.util.*;
import java.awt.*;

public class VasAppletEspion extends Applet {
  //decode une chaine codee en "www-url-encoded" vers sa forme normale
  //de telles chaines ont des '+' a la place de ' ' et
  //"% + valeur hexa" des caracteres differents de a-Z_0-9
  //par exemple ':' sera "%3A"
  /*
    chaine codee :
    http://127.0.0.1/New%20%2b%20Folder%20-'Best%20of%20%20all'%20%26%20cute/SecondTest.html
    chaine decodee :
    http://127.0.0.1/New + Folder -'Best of  all' & cute/SecondTest.html
  */
  private String decodeURL(String s) {
    if(s==null) return "";
    int i=0;
    StringBuffer finale=new StringBuffer();
    while(i < s.length()) {
      char c=s.charAt(i);
      if(c=='%' && i<s.length()-2) {
        try {
          c=(char)Integer.parseInt(s.substring(i+1, i+3), 16);
        }//try
        catch (Exception e) {c='?';}
        i+=2;
      }//if
      else {
        if(c=='+') {
          c=' ';
        }//if
      }//else
      i++;
      finale.append(c);
    }//while
    return finale.toString();
  }//decodeURL

  public String getAppletInfo() {
    return (new String("VasAppletEspion v2.3, 10 decembre 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//getAppletInfo

  //si le browser arrete le chargement de la page, on continue
  public void stop() {return;}

  public boolean handleEvent(Event e) {
    //les autres evenements ne seront pas traites
    return true;
  }//handleEvent

  //pour lire la reponse du serveur
  boolean lireReponse(DataInputStream in) {
    String ligne="";
    try {
      ligne=in.readLine();
    }//try
    catch(IOException e) {return true;}
    if(ligne.startsWith("4") || ligne.startsWith("5")) {
      return true;
    }//if
    else return false;
  }//lireReponse

  //mettre la couleur de fond et le message dans la barre d'etat
  private void metCouleurMsg(String couleur, String msg) {
    //on met le "bon" message
    getAppletContext().showStatus(msg);
    //on met la couleur de fond
    try{
      setBackground(new Color(Integer.parseInt(couleur.substring(1, 3), 16), Integer.parseInt(couleur.substring(3, 5), 16), Integer.parseInt(couleur.substring(5, 7), 16)));
    }//try
    catch(Exception ee) {;}
  }//metCouleurMsg

  //obtient l'information sur l'ordinateur
  private String obtientInfo() {
    StringBuffer aRetourner=new StringBuffer();
    Toolkit mt=Toolkit.getDefaultToolkit();
    Date md=new Date();
    aRetourner.append(
                      "Date_Heure="+md.toString()
                      +"\nDate_Heure Locale="+md.toLocaleString()
                      +"\nDate_Heure GMT="+md.toGMTString()
                      );

    String javaVendor=new String(System.getProperty("java.vendor"));
    //pour obtenir l'adresse IP de l'ordinateur
    //parfois MSIE donne des exceptions de securite et donne par contre toujours localhost
    //seulement Netscape et le browser de Sun donnent l'adresse IP
    if(javaVendor.startsWith("Nets") || javaVendor.startsWith("Sun")) {
      try {
        aRetourner.append(
                          "\naddresse IP="+InetAddress.getLocalHost().toString()
                          +"\nHom de l'hote="+InetAddress.getLocalHost().getHostName()
                          );
      }//try
      catch(Exception k) {aRetourner.append("\nAdresse IP non obtenue");}
    }//if
    else {
      aRetourner.append("\naddresse IP=localhost/127.0.0.1\nHom de l'hote=localhost");
    }//else

    aRetourner.append(
                      "\nSysteme="+System.getProperty("os.name")
                      +"\nVersion du systeme="+System.getProperty("os.version")
                      +"\nArchitecture du systeme="+System.getProperty("os.arch")
                      +"\nVendeur du navigateur="+javaVendor
                      +"\nURL du vendeur="+System.getProperty("java.vendor.url")
                      +"\nVersion de Java="+System.getProperty("java.version")
                      +"\nVersion des classes Java="+System.getProperty("java.class.version")
                      +"\nSeparateur de fichiers="+System.getProperty("file.separator")
                      +"\nSeparateur du \"path\"="+System.getProperty("path.separator")
                      +"\nSeparateur des lignes="
                      );

    //pour obtenir une belle representation du separateur de ligne
    String sl=new String(System.getProperty("line.separator"));
    for(int i=0; i<sl.length(); i++) {
      if(sl.charAt(i)=='\r') aRetourner.append("\\r");
      else {
        if(sl.charAt(i)=='\n') aRetourner.append("\\n");
        //pour les autres caracteres on met la representation numerique
        else aRetourner.append("\\"+((int)(sl.charAt(i))));
      }//else
    }//for

    aRetourner.append(
                      "\nMemoire totale de la JVM="+Runtime.getRuntime().totalMemory()
                      +"\nMemoire libre de la JVM="+Runtime.getRuntime().freeMemory()
                      +"\nURL de cette page="+getDocumentBase()
                      +"\nRacine de cette applet="+getCodeBase()
                      +"\nResolution du moniteur="+mt.getScreenResolution()+" points par puce"
                      +"\nTaille : largeur="+mt.getScreenSize().width+" hauteur="+mt.getScreenSize().height
                      +"\nEmplacement de l'applet sur l'ecran : x="+getParent().location().x+" y="+getParent().location().y
                      +"\nNombre de couleurs : "+mt.getColorModel().getPixelSize()+" bits/pixel, cad "+(int)Math.pow(2, mt.getColorModel().getPixelSize())+" couleurs"
                      );

    //on scanne toutes les polices Java
    String[] fonts=mt.getFontList();
    aRetourner.append("\nNombre de polices Java="+fonts.length+"\nPolices :");
    //et on les met dans le StringBufffer
    for(int i=0; i<fonts.length; i++) aRetourner.append("\n  "+(i+1)+" "+fonts[i]);

    //on regarde les applets tournants dans la JVM
    aRetourner.append("\nApplets :");
    int j=1;
    for(Enumeration enum=getAppletContext().getApplets(); enum.hasMoreElements();) aRetourner.append("\n  "+(j++)+" "+enum.nextElement());

    aRetourner.append("\n(C)1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    return aRetourner.toString();
  }//obtientInfo

  public void init() {
//security
/*
    String base=getDocumentBase().toString().toLowerCase();
    if(base.indexOf("dents")!=-1 && base.indexOf("video")!=-1) {
      //here we bother the user of this site by sending him to my page
      try {
        getAppletContext().showDocument(new URL("http://www.chez.com/vasile/vasregfr.html"));
        //exiting without sending mails
        return;
      }//try
      //apparently we got a security exception
      catch (Exception eeeee) {
        //here we bother the user of this site by sending him to codeBase page
        try {
          getAppletContext().showDocument(getCodeBase());
          //exiting without sending mails
          return;
        }//try
        //apparently we got a security exception
        catch (Exception eeee) {return;}
      }//catch
    }//if
*/
//end_security
//date
/*
    Date md=new Date();
    if(md.after(new Date(99, 11, 9))) {
      //here we bother the user of this site by sending them to codeBase page
      try {
        getAppletContext().showDocument(new URL("http://www.chez.com/vasile/vasregfr.html"));
        //exiting without sending mails
        return;
      }//try
      //apparently we got a security exception
      catch (Exception eeeee) {
        try {
          getAppletContext().showDocument(getCodeBase());
          //exiting without sending mails
          return;
        }//try
        //apparently we got a security exception
        catch (Exception eeee) {return;}
      }//catch
    }//if
*/
//end_date
    //nous prenons les valeurs du "referrer" et "browser" fournies par JavaScript et la page web
    String referrer=getParameter("referrer");
    String browser=getParameter("browser");

    //on prends le parametre "de" depuis la page HTML
    String de=getParameter("de");
    //la valeur de l'adresse "de" par defaut
    //il vaut mieux de la changer avant compilation
    if(de==null) de=new String("vasile@chez.com");

    //on prends le parametre "vers" depuis la page HTML
    String vers=getParameter("vers");
    //la valeur de l'adresse "vers" par defaut
    //il vaut mieux de la changer avant compilation
    if(vers==null) vers=new String("vasile@wook.com");

    //on prends le parametre depuis la page HTML
    String sujet=getParameter("sujet");
    //la valeur du sujet par defaut
    if(sujet==null) sujet=new String("VasAppletEspion");

    //la couleur du fond de l'applet (le meilleur c'est d'avoir le meme que celui da la page HTML)
    //par example #000000 pour le noir ou #FFFFFF pour le blanc
    //on prends le parametre depuis la page HTML
    String couleur=getParameter("couleur");
    if(couleur==null) couleur=new String("#B4B88C");

    //le message qui sera affiche dans le StatusBar
    //on prends les parametres depuis la page HTML
    String msg=getParameter("msg");
    if(msg==null) msg=new String("Hello");
    metCouleurMsg(couleur, msg);

    String touteInfo=new String(
                                "Referrer="+decodeURL(referrer)
                                +"\nBrowser="+decodeURL(browser)
                                +"\n"+obtientInfo()
                                );
//security
/*
    touteInfo=new String(
                         "De la part de l'auteur : MERCI d'avoir essaye cette applet !"
                         +"\nSi vous l'utilisez depuis plus de 20 jours, n'oubliez pas de vous enregistrer !"
                         +"\nCa coute SEULEMENT $12(50FF) pour une utilisation personnelle ! Pour plus d'infos, allez sur :"
                         +"\nhttp://www.chez.com/vasile/vasregfr.html"
                         +"\nApres 20 jours l'applet redirigera le browser vers cette page.\n"
                         +touteInfo
                       );
*/
//end_security

    goConnexion(de, vers, sujet, touteInfo);
    metCouleurMsg(couleur, msg);
  }//init

  //envoie un email
  private void goConnexion(String from, String to, String subj, String data) {
    try {
      Socket sock=new Socket(getCodeBase().getHost(), 25);
      DataOutputStream out=new DataOutputStream(sock.getOutputStream());
      DataInputStream in=new DataInputStream(sock.getInputStream());
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("HELO vasile.md\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("MAIL FROM:<"+from+">\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("RCPT TO:<"+to+">\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("DATA\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      out.writeBytes("Subject: "+subj+"\n\n");
      out.writeBytes(data+"\r\n.\r\nQUIT\r\n");
      if(lireReponse(in)) {sock.close(); return;}
      sock.close();
    }//try
    catch(Exception e) {;}
  }//goConnexion
}//classe VasAppletEspion
